#include <PCF8574.h>
#include <Wire.h>
#include <SPI.h>
#include <nRF24L01.h>
#include <RF24.h>

PCF8574 e1;
//PCF8574 e2;

#define M1_A 2
#define M1_B 4
#define M2_A 7
#define M2_B 8
#define M1_PWN 6
#define M2_PWN 5

#define S1 A0
#define S2 A1
#define S3 A2
#define S4 A3
#define S5 A6
#define S6 A7

#define czujnikOptyczny 20
int odczytLewy = 0;
int odczytPrawy = 0;

// NRF {
#define CE_PIN   9
#define CSN_PIN 10

int x_hiz = 0;
int y_hiz = 0;

const uint64_t pipe = 0xE8E8F0F0E1LL;

RF24 radio(CE_PIN, CSN_PIN);

int data[11];
// NRF }

void setup()
{
  pinMode(M1_A , OUTPUT); pinMode(M1_B , OUTPUT);
  pinMode(M2_A , OUTPUT); pinMode(M2_B , OUTPUT);

  radio.begin();
  radio.setChannel(121);
  radio.setPALevel(RF24_PA_MAX);
  radio.setDataRate(RF24_250KBPS);

  radio.openReadingPipe(1, pipe);
  radio.startListening();

  e1.begin(0x38);
  //e2.begin(0x39);

  e1.pinMode(0, OUTPUT);
  e1.pinMode(1, OUTPUT);
  e1.pinMode(2, OUTPUT);
  e1.pinMode(3, OUTPUT);
  e1.pinMode(4, OUTPUT);
  e1.pinMode(5, OUTPUT);
  e1.pinMode(6, OUTPUT);
  e1.pinMode(7, OUTPUT);
/*
  e2.pinMode(0, OUTPUT);
  e2.pinMode(1, OUTPUT);
  e2.pinMode(2, OUTPUT);
  e2.pinMode(3, OUTPUT);
  e2.pinMode(4, OUTPUT);
  e2.pinMode(5, OUTPUT);
  e2.pinMode(6, OUTPUT);
  e2.pinMode(7, OUTPUT);
*/
  Serial.begin(9600);
}


void loop()
{
  if ( radio.available() )
  {
    radio.read( data, sizeof(data) );
    odczyt(data[0], data[1], data[2], data[3], data[4], data[5], data[6], data[7], data[8], data[9], data[10]);
  }
  //delay(10);
}

void tyl() {
  digitalWrite(M1_A, 0); digitalWrite(M1_B, 1);
  digitalWrite(M2_A, 0); digitalWrite(M2_B, 1);
}

void przod() {
  digitalWrite(M1_A, 1); digitalWrite(M1_B, 0);
  digitalWrite(M2_A, 1); digitalWrite(M2_B, 0);
}

void lewo() {
  digitalWrite(M1_A, 1); digitalWrite(M1_B, 0);
  digitalWrite(M2_A, 0); digitalWrite(M2_B, 1);
}

void prawo() {
  digitalWrite(M1_A, 0); digitalWrite(M1_B, 1);
  digitalWrite(M2_A, 1); digitalWrite(M2_B, 0);
}
void zerowanie() {
  digitalWrite(M1_A, 0); digitalWrite(M1_B, 0);
  digitalWrite(M2_A, 0); digitalWrite(M2_B, 0);
}
void liniaLewo() {
    digitalWrite(M1_A, 0); digitalWrite(M1_B, 0);
  digitalWrite(M2_A, 1); digitalWrite(M2_B, 0);
}

void liniaPrawo() {

  digitalWrite(M1_A, 1); digitalWrite(M1_B, 0);
  digitalWrite(M2_A, 0); digitalWrite(M2_B, 0);
}
void odczyt(int x_axis, int y_axis, int button1, int button2, int button3, int button4, int button5, int button6, int button7, int px_axis, int py_axis) {
  if (button2 == false) {
    e1.digitalWrite(1, HIGH);
    e1.digitalWrite(2, HIGH);
  } else if (button4 == false) {
    e1.digitalWrite(3, HIGH);
    e1.digitalWrite(4, HIGH);
  } else if (button3 == false) {
    e1.digitalWrite(5, HIGH);
    e1.digitalWrite(6, HIGH);
  } else if (button1 == false) {
    e1.digitalWrite(1, HIGH);
    e1.digitalWrite(2, HIGH);
    e1.digitalWrite(3, HIGH);
    e1.digitalWrite(4, HIGH);
    e1.digitalWrite(5, HIGH);
    e1.digitalWrite(6, HIGH);
  } else if (button6 == false) {
    e1.digitalWrite(1, HIGH);
    e1.digitalWrite(2, HIGH);
    e1.digitalWrite(3, HIGH);
    e1.digitalWrite(4, HIGH);
    e1.digitalWrite(5, HIGH);
    e1.digitalWrite(6, HIGH);
    odczytLewy = analogRead(A2);
    odczytPrawy = analogRead(A3);
    Serial.print("L: "); Serial.println(analogRead(A2));
    Serial.print("P: "); Serial.println(analogRead(A3));
  } else {
    e1.digitalWrite(1, LOW);
    e1.digitalWrite(2, LOW);
    e1.digitalWrite(3, LOW);
    e1.digitalWrite(4, LOW);
    e1.digitalWrite(5, LOW);
    e1.digitalWrite(6, LOW);
  }
  if (py_axis > 650) {

    analogWrite(M1_PWN,  110);
    analogWrite(M2_PWN,  110);
    if (analogRead(A0) > czujnikOptyczny and analogRead(A1) > czujnikOptyczny) {
      e1.digitalWrite(1, 1);
      e1.digitalWrite(2, 1);
      tyl();
      delay(100);
      lewo();
      delay(100);
    } else if (analogRead(A1) > czujnikOptyczny or analogRead(A6) > czujnikOptyczny) {
      if (analogRead(A1) > czujnikOptyczny) {
        e1.digitalWrite(2, 1);
        tyl();
        delay(100);
      }
      if (analogRead(A6) > czujnikOptyczny)
        e1.digitalWrite(5, 1);
      prawo();
      delay(30);
    } else if (analogRead(A0) > czujnikOptyczny or analogRead(A7) > czujnikOptyczny) {
      if (analogRead(A0) > czujnikOptyczny) {
        e1.digitalWrite(1, 1);
        tyl();
        delay(100);
      }
      if (analogRead(A7) > czujnikOptyczny) e1.digitalWrite(6, 1);
      lewo();
      delay(30);
    } else {
      e1.digitalWrite(1, LOW);
      e1.digitalWrite(2, LOW);
      e1.digitalWrite(3, LOW);
      e1.digitalWrite(4, LOW);
      e1.digitalWrite(5, LOW);
      e1.digitalWrite(6, LOW);
      przod();
    }
  }

  if (py_axis < 450) {
    analogWrite(M1_PWN,  120);
    analogWrite(M2_PWN,  120);
    //liniaLewo();
    
    Serial.print("L: "); Serial.println(analogRead(A2));
    Serial.print("P: "); Serial.println(analogRead(A3));
    //delay(500);
    if (analogRead(A2) < (odczytLewy - 50) and analogRead(A3) > (odczytPrawy - 20)) {
      liniaPrawo();
    } else if (analogRead(A2) > (odczytLewy - 20) and analogRead(A3) < (odczytPrawy - 50)) {
      liniaLewo();
    } else if (analogRead(A2) > (odczytLewy - 20) and analogRead(A3) > (odczytPrawy - 20)) {
     liniaLewo();
    }
    
  }

  y_hiz = 0;
  x_hiz = 0;
  if (y_axis > 650) {
    y_hiz =  map(y_axis, 650, 1023, 0, 250);
    analogWrite(M1_PWN,  y_hiz);
    analogWrite(M2_PWN,  y_hiz);
    przod();
    if (px_axis > 650) {
      x_hiz =  map(px_axis, 650, 1023, 0, 250);
      analogWrite(M1_PWN,  x_hiz);
      analogWrite(M2_PWN,  x_hiz);
      prawo();
    }
    if (x_axis < 350) {
      x_hiz =  map(x_axis, 350, 0, 0, 250);
      analogWrite(M1_PWN,  x_hiz);
      analogWrite(M2_PWN,  x_hiz);
      lewo();
    }

  } else if (y_axis < 350) {
    y_hiz =  map(y_axis, 350, 0, 0, 250);
    analogWrite(M1_PWN,  y_hiz);
    analogWrite(M2_PWN,  y_hiz);
    tyl();
    if (x_axis > 650) {
      x_hiz =  map(x_axis, 650, 1023, 0, 250);
      analogWrite(M1_PWN,  x_hiz);
      analogWrite(M2_PWN,  x_hiz);
      lewo();
    }
    if (x_axis < 350) {
      x_hiz =  map(x_axis, 350, 0, 0, 250);
      analogWrite(M1_PWN,  x_hiz);
      analogWrite(M2_PWN,  x_hiz);
      prawo();
    }
  } else  if (x_axis > 650) {
    x_hiz =  map(x_axis, 650, 1023, 0, 250);
    analogWrite(M1_PWN,  x_hiz);
    analogWrite(M2_PWN,  x_hiz);
    lewo();
  } else if (x_axis < 350) {
    x_hiz =  map(x_axis, 350, 0, 0, 250);
    analogWrite(M1_PWN,  x_hiz);
    analogWrite(M2_PWN,  x_hiz);
    prawo();
  } else {
    if (py_axis <640 and py_axis >460 )
      zerowanie();
  }
}
